#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************

. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds

# Get ibmQseInst_PW Password for the setup
# ======================================
tempibmQseInst_PW=`echo ${ibmQseInst_PW} | base64 -d`

temp_teamserver_properties=$1
repoComponent=$2

echo "file to update is ["$temp_teamserver_properties"]"
echo "component is ["$repoComponent"]"
echo "===== DB2 updates ====="


# ---------------------------- CLM ----------------------------
if [ "jts" == $repoComponent ] || [ "ccm" == $repoComponent ] || [ "qm" == $repoComponent ] || [ "rm" == $repoComponent ] || [ "dcc" == $repoComponent ] || [ "gc" == $repoComponent ]; then 
  echo "-------------update [$repoComponent] teamserver property file--------------------"
  sed -i s%_DBVENDOR_%db2% $temp_teamserver_properties
  sed -i s%#_DB2_CONNECTION_STRING_%com.ibm.team.repository.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_MOD_DB_PORT_%$DB2PORT% $temp_teamserver_properties
  sed -i s%_MOD_PASSWORD_%$tempibmQseInst_PW% $temp_teamserver_properties
  sed -i s%_MOD_ADMIN_USER_%$ibmQseInst_User% $temp_teamserver_properties
  sed -i s%_DATAWAREHOUSEVENDOR_%db2% $temp_teamserver_properties
  sed -i s%#_DB2_DW_CONNECTION_STRING_%com.ibm.team.datawarehouse.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_DW_DB_PORT_%$DB2PORT% $temp_teamserver_properties
  sed -i s%_DW_TABLE_NAME_%$dwDBName% $temp_teamserver_properties
  sed -i s%_DW_PASSWORD_%$tempibmQseInst_PW% $temp_teamserver_properties
  sed -i s%_DW_ADMIN_USER_%$ibmQseInst_User% $temp_teamserver_properties
  
  sed -i s%_CLM_COMPONENT_%$repoComponent% $temp_teamserver_properties

  MOD_TABLE_NAME_var=${repoComponent}DBName
  eval MOD_TABLE_NAME=\$$MOD_TABLE_NAME_var
  
  echo "MOD_TABLE_NAME ["$MOD_TABLE_NAME"]"
  sed -i s%_MOD_TABLE_NAME_%$MOD_TABLE_NAME% $temp_teamserver_properties
  
  sed -i s%_DW_BASE_FOLDER_%${QD_Root}/DWFolder% $temp_teamserver_properties
fi


# ---------------------------- RELM / VVC / DM ----------------------------
if [ "relm" == $repoComponent ] || [ "vvc" == $repoComponent ] || [ "dm" == $repoComponent ]; then
  echo "-------------update [$repoComponent] teamserver property file--------------------"
  sed -i s%_DBVENDOR_%db2% $temp_teamserver_properties
  sed -i s%#_DB2_CONNECTION_STRING_%com.ibm.team.repository.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_MOD_DB_PORT_%$DB2PORT% $temp_teamserver_properties

  MOD_TABLE_NAME_var=${repoComponent}DBName
  eval MOD_TABLE_NAME=\$$MOD_TABLE_NAME_var
  echo "MOD_TABLE_NAME ["$MOD_TABLE_NAME"]"
  sed -i s%_MOD_TABLE_NAME_%$MOD_TABLE_NAME% $temp_teamserver_properties
  sed -i s%_MOD_PASSWORD_%$tempibmQseInst_PW% $temp_teamserver_properties
  sed -i s%_MOD_ADMIN_USER_%$ibmQseInst_User% $temp_teamserver_properties
fi

#------------------------------lqe and ldx ----------------------
if [ "lqe" == $repoComponent ] || [ "ldx" == $repoComponent ]; then
   echo " ----------- update [$repoComponent] dbconnection property file -----------"
   sed -i s%#_DB2_CONNECTION_STRING_%% $temp_teamserver_properties
   sed -i s%_MOD_DB_PORT_%$DB2PORT% $temp_teamserver_properties

   MOD_TABLE_NAME_var=${repoComponent}DBName
   eval MOD_TABLE_NAME=\$$MOD_TABLE_NAME_var
   echo "MOD_TABLE_NAME ["$MOD_TABLE_NAME"]"
   sed -i s%_MOD_TABLE_NAME_%$MOD_TABLE_NAME% $temp_teamserver_properties
   sed -i s%_MOD_PASSWORD_%$tempibmQseInst_PW% $temp_teamserver_properties
   sed -i s%_MOD_ADMIN_USER_%$ibmQseInst_User% $temp_teamserver_properties
fi
echo "===== DB2 updates completed ====="
exit 0
