#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************

if [ -f /etc/db.properties ]
then
   . /etc/db.properties
else
   echo "Error: missing /etc/db.properties file"
   exit 1
fi
temp_teamserver_properties=$1
repoComponent=$2

echo "file to update is ["$temp_teamserver_properties"]"
echo "component is ["$repoComponent"]"
echo "===== oracle updates ====="


# ---------------------------- CLM ----------------------------
if [ "jts" == $repoComponent ] || [ "ccm" == $repoComponent ] || [ "qm" == $repoComponent ] || [ "rm" == $repoComponent ] || [ "dcc" == $repoComponent ] || [ "gc" == $repoComponent ]; then 
  echo "-------------update [$repoComponent] teamserver property file--------------------"
  sed -i s%_DBVENDOR_%oracle% $temp_teamserver_properties
  sed -i s%#_ORACLE_CONNECTION_STRING_%com.ibm.team.repository.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_MOD_DB_PORT_%1521% $temp_teamserver_properties
  sed -i s%_ORACLE_SERVICE_NAME_%CLMINST% $temp_teamserver_properties
  sed -i s%_DATAWAREHOUSEVENDOR_%oracle% $temp_teamserver_properties
  sed -i s%#_ORACLE_DW_CONNECTION_STRING_%com.ibm.team.datawarehouse.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_DW_DB_PORT_%1521% $temp_teamserver_properties
  sed -i s%_DW_ORACLE_USER_%dwUSR% $temp_teamserver_properties
  sed -i s%_DW_PASSWORD_%dwUSR% $temp_teamserver_properties
  
  sed -i s%_CLM_COMPONENT_%$repoComponent% $temp_teamserver_properties
 
  MOD_ORACLE_DB_USER=${repoComponent}USR
  MOD_PASSWORD=${repoComponent}USR
  echo "MOD_ORACLE_DB_USER ["$MOD_ORACLE_DB_USER"]"
  echo "MOD_PASSWORD ["$MOD_PASSWORD"]"
  sed -i s%_MOD_ORACLE_DB_USER_%$MOD_ORACLE_DB_USER% $temp_teamserver_properties
  sed -i s%_MOD_PASSWORD_%$MOD_PASSWORD% $temp_teamserver_properties
   
  sed -i s%_DW_BASE_FOLDER_%${QD_Root}/DWFolder% $temp_teamserver_properties
fi


# ---------------------------- RELM / VVC / DM ----------------------------
if [ "relm" == $repoComponent ] || [ "vvc" == $repoComponent ] || [ "dm" == $repoComponent ]; then
  echo "-------------update [$repoComponent] teamserver property file--------------------"
  sed -i s%_DBVENDOR_%oracle% $temp_teamserver_properties
  sed -i s%#_ORACLE_CONNECTION_STRING_%com.ibm.team.repository.db.jdbc.location% $temp_teamserver_properties
  sed -i s%_MOD_DB_PORT_%1521% $temp_teamserver_properties
  
  MOD_ORACLE_DB_USER=${repoComponent}USR
  MOD_PASSWORD=${repoComponent}USR
  echo "MOD_ORACLE_DB_USER ["$MOD_ORACLE_DB_USER"]"
  echo "MOD_PASSWORD ["$MOD_PASSWORD"]"
  sed -i s%_MOD_ORACLE_DB_USER_%$MOD_ORACLE_DB_USER% $temp_teamserver_properties
  sed -i s%_MOD_PASSWORD_%$MOD_PASSWORD% $temp_teamserver_properties
  
  sed -i s%_ORACLE_SERVICE_NAME_%CLMINST% $temp_teamserver_properties
  
fi

# -----------------------------lqe and ldx --------------------------------
if [ "lqe" == $repoComponent ] || [ "ldx" == $repoComponent ]; then
   echo " ----------- update [$repoComponent] dbconnection property file -----------"
   sed -i s%#_ORACLE_CONNECTION_STRING_%% $temp_teamserver_properties
   sed -i s%_MOD_DB_PORT_%1521% $temp_teamserver_properties
   
   MOD_ORACLE_DB_USER=${repoComponent}USR
   MOD_PASSWORD=${repoComponent}USR
   echo "MOD_ORACLE_DB_USER ["$MOD_ORACLE_DB_USER"]"
   echo "MOD_PASSWORD ["$MOD_PASSWORD"]"
   sed -i s%_MOD_ORACLE_DB_USER_%$MOD_ORACLE_DB_USER% $temp_teamserver_properties
   sed -i s%_MOD_PASSWORD_%$MOD_PASSWORD% $temp_teamserver_properties
   
   sed -i s%_ORACLE_SERVICE_NAME_%CLMINST% $temp_teamserver_properties
fi
echo "===== oracle updates completed ====="
exit 0
