#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************

. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds

# command to change file mode for OSUser
sshChmodRead="sudo chmod o+r $userCreds"
sshChmodRevert="sudo chmod 600 $userCreds"

#######################
# ---- Functions ---- #
#######################


# usage restartSingleWAS() appName serverHost
restartSingleWAS()
{
    appName=$1
    serverHost=$2
    
		echo "=== restarting WAS process on $appName [$serverHost] ==="
		echo "-------------------------------------"    
    echo "getting WASCommon directory name..."
    tempWASdir=`ssh $OSUserName@$serverHost grep -m 1 WAS_COMMON_DIR /etc/env.properties | cut -d = -f2`
    echo "WASCommon directory name [$tempWASdir]"
    echo "restarting WAS..."
    ssh -t -t -o ConnectTimeout=30 $OSUserName@$serverHost "$sshChmodRead"
    ssh -o ConnectTimeout=600 $OSUserName@$serverHost "echo "y" | sh ${tempWASdir}/WASScripts/RestartSingleWAS.sh"
    if [ $? -gt 0 ]; then
	   echo "ERROR: failed to restart WAS as [$OSUserName@$serverHost]"
	   exit 1
	fi
    ssh -t -t -o ConnectTimeout=30 $OSUserName@$serverHost "$sshChmodRevert"
    echo "-------------------------------------"
}

echo "--- restarting WAS processes ---"
i=1
while [ $i -le $NUMBER_OF_CUSTOM_NODES ]
do
	c_host_var=NODE${i}_HostName
    eval c_host=\$$c_host_var
    
    app_var=NODE${i}_AppList
    eval apps=\$$app_var
	
	restartSingleWAS "$apps" $c_host
	if [ $? -gt 0 ]; then
	   echo "ERROR: failed to restart WAS on node [$c_host] as [$OSUserName@$serverHost]"
	   exit 1
	fi
	i=$(( i+1 ))
done
echo "--- WAS processes restarted ---"

