#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************

. /etc/env.properties

httpConfFile=${IHS_ROOT}/conf/httpd.conf

# assume at least one WAS server always present
sed -i 's%WebSpherePluginConfig%#WebSpherePluginConfig%' $httpConfFile
echo "LoadModule was_ap22_module ${Plugins_ROOT}/bin/64bits/mod_was_ap22_http.so" >> $httpConfFile
echo "WebSpherePluginConfig ${Plugins_ROOT}/config/webservermerge/plugin-cfg.xml" >> $httpConfFile
echo "LoadModule ibm_ssl_module modules/mod_ibm_ssl.so" >> $httpConfFile


if [ "unknown" != "$dwaWebserverHostName" ]; then
  # DWA present, so proxy required

  sed -i 's%#LoadModule proxy_module modules/mod_proxy.so%LoadModule proxy_module modules/mod_proxy.so%' $httpConfFile
  sed -i 's%#LoadModule proxy_http_module modules/mod_proxy_http.so%LoadModule proxy_http_module modules/mod_proxy_http.so%' $httpConfFile

  ## ports 8080 and 8443 here for future reference
  
  # echo "Listen 8080" >> $httpConfFile
  # echo "<VirtualHost *:8080>" >> $httpConfFile
  # echo "ProxyPreserveHost On" >> $httpConfFile
  # echo "ProxyPass / http://<dwa.host>:8080/" >> $httpConfFile
  # echo "ProxyPassReverse / http://<dwa.host>:8080/" >> $httpConfFile
  # echo "</VirtualHost>" >> $httpConfFile

  # echo "Listen 8443" >> $httpConfFile
  # echo "<VirtualHost *:8443>" >> $httpConfFile
  # echo "SSLEnable" >> $httpConfFile
  # echo "SSLProxyEngine on" >> $httpConfFile
  # echo "SSLServerCert ihsserver" >> $httpConfFile
  # echo "ProxyPass / https://<dwa.host>:8443/" >> $httpConfFile
  # echo "ProxyPassReverse / https://<dwa.host>:8443/" >> $httpConfFile
  # echo "ProxyPreserveHost On" >> $httpConfFile
  # echo "</VirtualHost>" >> $httpConfFile

  ## port 9080 for DWA http
  ## and 9443 here for the shared "jazz https port 9443"
  ## deal with 9443 seperately

  echo "Listen 9080" >> $httpConfFile
  echo "<VirtualHost *:9080>" >> $httpConfFile
  echo "ProxyPreserveHost On" >> $httpConfFile
  echo "ProxyPass / http://$dwaWebserverHostName:8080/" >> $httpConfFile
  echo "ProxyPassReverse / http://$dwaWebserverHostName:8080/" >> $httpConfFile
  echo "</VirtualHost>" >> $httpConfFile

fi

## 9443 always present, some times it also has DWA present
## common bit first
echo "Listen 9443" >> $httpConfFile
echo "<VirtualHost *:9443>" >> $httpConfFile
echo "SSLEnable" >> $httpConfFile
echo "SSLServerCert ihsserver" >> $httpConfFile
echo " " >> $httpConfFile

## placeholders for the sp800 security that may get enabled later
echo "#_sp800_SSLProtocolEnable TLSv12" >> $httpConfFile
echo "#_sp800_SSLProtocolDisable SSLv2 SSLv3 TLSv1 TLSv11" >> $httpConfFile
##echo "#_sp800_SSLServerCert selfSigned" >> $httpConfFile
echo "#_sp800_SSLFIPSEnable" >> $httpConfFile
echo "#_sp800_KeyFile /opt/IBM/HTTPServer/conf/jtswebserver.kdb" >> $httpConfFile
echo "#_sp800_SSLStashFile /opt/IBM/HTTPServer/conf/jtswebserver.sth" >> $httpConfFile
echo " " >> $httpConfFile

if [ "unknown" != "$dwaWebserverHostName" ]; then
  ## DWA and JAZZ proxy part only needed when DWA present
 
 	i=1
	while [ $i -le $NUMBER_OF_CUSTOM_NODES ]
	do
   		app_var=NODE${i}_AppList
   		eval apps=\$$app_var
   
   		apps=${apps//,/ }
   		for a in $apps
   		do
      		echo "ProxyPass /$a !" >> $httpConfFile
      		if [ $a == jts ]
      		then
      			echo "ProxyPass /clmhelp !" >> $httpConfFile
      		fi
   		done    
   		i=$(( i+1 ))
	done

  echo "ProxyPass / https://$dwaWebserverHostName:8443/" >> $httpConfFile
  echo "ProxyPassReverse / https://$dwaWebserverHostName:8443/" >> $httpConfFile
  echo "ProxyPreserveHost On" >> $httpConfFile

fi

## and finally close the 9443 section
echo "</VirtualHost>" >> $httpConfFile
echo " " >> $httpConfFile

# assume this is common and last
echo "KeyFile /opt/IBM/HTTPServer/ihsserverkey.kdb" >> $httpConfFile
echo "SSLStashFile /opt/IBM/HTTPServer/ihsserverkey.sth" >> $httpConfFile
echo "SSLDisable" >> $httpConfFile
echo "SetEnv websphere-nocanon 1" >> $httpConfFile
