#!/bin/bash
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************
. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds

# Get WAS admin password
# ======================================
tempPassword=`echo ${WAS_PASSWORD} | base64 -d`

echo "Temporary copy LDAPSecurity.properties file to back up...."
cp $WAS_COMMON_DIR/LDAP/LDAPSecurity.properties $WAS_COMMON_DIR/LDAP/LDAPSecurity_temp.properties
sed -i s/${WAS_PASSWORD}/$tempPassword/ $WAS_COMMON_DIR/LDAP/LDAPSecurity.properties

export ihshost=$1
export WebserverName=$2

thisScriptDir=`pwd`    ## is this bullet proof, only if run from the script dir!!

echo "Create WebServer" $WebserverName

command="AdminTask.createWebServerByHostName('[-webserverName $WebserverName -templateName IHS -webPort 80 -serviceName -webInstallRoot /opt/IBM/HTTPServer -webProtocol HTTP -configurationFile -errorLogfile -accessLogfile -pluginInstallRoot /opt/IBM/Plugins -webAppMapping ALL -hostName $ihshost -platform linux -adminPort 8008 -adminUserID $WAS_USER_NAME -adminPasswd $tempPassword -adminProtocol HTTP]')"

#/opt/IBM/WebSphere/AppServer/bin/wsadmin.sh -lang jython -c "$command"
su -c "WebserverName=$WebserverName ihshost=$ihshost /opt/IBM/WebSphere/AppServer/bin/wsadmin.sh -lang jython -f ${thisScriptDir}/CreateWebServer.jy $WAS_COMMON_DIR" -- $OSUserName

echo "Move back original LDAPSecurity.properities file...."
mv -f $WAS_COMMON_DIR/LDAP/LDAPSecurity_temp.properties $WAS_COMMON_DIR/LDAP/LDAPSecurity.properties
