#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************
. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds
if [ $? -gt 0 ]; then
     echo "ERROR: failed to source file [$userCreds]"
     exit 1
fi
#############################################################################
#
# Inputs - taken from 'environment'
#        - optional arguments: username password
#          Use these arguments after disabling admin security on WAS.
#	   You need to restart the server by passing in the old creds
#  	   to stop the server, then no creds to start the server.
#
#############################################################################

if [ "$1" -a "$2" ]; then creds="-username $1 -password $2"; fi


#check the user who initiate this script
CurrentUser=`whoami`

if [ "$CurrentUser" == root ]; then
   su - $WAS_USER_NAME -c "$WAS_PROFILE_ROOT/bin/stopServer.sh server1 $creds"
   sleep 30
   su - $WAS_USER_NAME -c "$WAS_PROFILE_ROOT/bin/startServer.sh server1"
else
   $WAS_PROFILE_ROOT/bin/stopServer.sh server1 $creds
   sleep 30
   $WAS_PROFILE_ROOT/bin/startServer.sh server1
fi
if [ $? -ne 0 ]
then
echo "WebSphere Server failed to start"
exit 1
fi
echo "WebSphere Server restarted."
exit 0
