#!/bin/sh
#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************
. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds

# Get RootPassword for the setup
# ======================================
tempRootPassword=`echo ${RootPassword} | base64 -d`


DMGR=$1
APP1=$2
APP2=$3

echo "Server node variables from parameter pass"
echo "DMGR node: $DMGR" 
echo "APP1 node: $APP1"
echo "APP2 node: $APP2"

echo " "
echo "Server node variables from virtualimage.properties"
echo "DMGR node: $dmgrhost"
echo "APP1 node: $appnode1"
echo "APP2 node: $appnode2"

# expect package installed on all servers is a system preReq

echo "set up ssh on dmgr machines..."
${WAS_COMMON_DIR}/sshScripts/setupSSH -p $tempRootPassword root@$appnode1
${WAS_COMMON_DIR}/sshScripts/setupSSH -p $tempRootPassword root@$appnode2


echo "copy setup ssh scripts for other nodes ...."
scp ${WAS_COMMON_DIR}/sshScripts/setupSSH root@$appnode1:/tmp
scp ${WAS_COMMON_DIR}/sshScripts/setupSSH root@$appnode2:/tmp

echo "executing setupSSH from appnode2 to appnode1"
ssh root@$appnode2 "/tmp/setupSSH -p $tempRootPassword root@$appnode1"

