#********************************************************************************
# Licensed Materials - Property of IBM
# IBM Quick Deployer
# (c) Copyright IBM Corporation 2015. All Rights Reserved.
#
# U.S. Government Users Restricted Rights:
# Use, duplication or disclosure restricted by GSA ADP Schedule
# Contract with IBM Corp.
#
#********************************************************************************
createDB2Section()
{
   appName=$1
   DBHost=$2
   appNumber=$3
   if [ $appNumber -eq 0 ]; then
      EntryHead=$appName
   else
      EntryHead=$appName.$appNumber
   fi
   
   DBTableName_var=${appName}DBName
   eval DBTableName=\$$DBTableName_var
   echo "DBTableName: [$DBTableName]"
   
   # [rs] does not have a database. all other apps do
   if [ $appName == rs ]; then
      echo "$EntryHead\\:com.ibm.team.jrs.setupStep\\:db.jdbc.password=$tempibmQseInst_PW" >> $BuildResponseFile
   else
      echo "$EntryHead\\:configure.database.page\\:db.jdbc.location=//$DBHost\\:$DB2PORT/$DBTableName\\:user\\=$ibmQseInst_User;password\\={password};" >> $BuildResponseFile 
      echo "$EntryHead\\:configure.database.page\\:db.jdbc.password=$tempibmQseInst_PW" >> $BuildResponseFile 
      echo "$EntryHead\\:configure.database.page\:db.type=JDBC" >> $BuildResponseFile
      echo "$EntryHead\\:configure.database.page\:db.vendor=DB2" >> $BuildResponseFile
   fi
   
   if [ $appName == ccm ] || [ $appName == qm ] || [ $appName == rm ] || [ $appName == dcc ]; then
      echo "$EntryHead\\:data.warehouse.page\\:db.base.folder=/db2fs/db2inst1" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.jdbc.location=//$DBHost\\:$DB2PORT/$dwDBName\\:user\\=$ibmQseInst_User;password\\={password};" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.jdbc.password=$tempibmQseInst_PW" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.type=JDBC" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.vendor=DB2" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:report.user=RPTUSER" >> $BuildResponseFile
   fi
}


createOracleSection()
{
   appName=$1
   DBHost=$2
   appNumber=$3
   if [ $appNumber -eq 0 ]; then
     EntryHead=$appName
   else
      EntryHead=$appName.$appNumber
   fi
   
   if [ $appName == rs ]; then
      echo "$EntryHead\\:com.ibm.team.jrs.setupStep\\:db.jdbc.password=dwUSR" >> $BuildResponseFile
   else
      echo "$EntryHead\\:configure.database.page\\:db.jdbc.location=thin\:${appName}USR/{password}@//$DBHost\:1521/CLMINST" >> $BuildResponseFile   
      echo "$EntryHead\\:configure.database.page\\:db.jdbc.password=${appName}USR" >> $BuildResponseFile 
      echo "$EntryHead\\:configure.database.page\:db.type=JDBC" >> $BuildResponseFile
      echo "$EntryHead\\:configure.database.page\:db.vendor=ORACLE" >> $BuildResponseFile
   fi

   if [ $appName == ccm ] || [ $appName == qm ] || [ $appName == rm ] || [ $appName == dcc ]; then
      echo "$EntryHead\\:data.warehouse.page\\:db.base.folder=/oracle/tmp" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.jdbc.location=thin\:dwUSR/{password}@//$DBHost\:1521/CLMINST" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.jdbc.password=dwUSR" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.type=JDBC" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:db.vendor=ORACLE" >> $BuildResponseFile
      echo "$EntryHead\\:data.warehouse.page\\:report.user=RPTUSER" >> $BuildResponseFile
   fi
 }


createDatabaseSection()
{
   ApplicationName=$1
   DB_Host=$2
   nonlocalAppNumber=$3
   
   if [ $DB_VENDOR == db2 ]
   then
      createDB2Section $ApplicationName $DB_Host $nonlocalAppNumber
   else
      if [ $DB_VENDOR == oracle ]
      then
         createOracleSection $ApplicationName $DB_Host $nonlocalAppNumber
      else
         echo "Not supported database: [ $DB_VENDOR ]"
         exit 1
      fi
   fi
}


createCommonDatabaseSection()
{
   if [ $DB_VENDOR == db2 ]
   then
      # build DB2 common section
      # configure database
      echo "configure.database.page\:db.jdbc.location=//$DB_HOSTNAME\:$DB2PORT/$jtsDBName\:user\=$ibmQseInst_User;password\={password};" >> $BuildResponseFile
      echo "configure.database.page\:db.jdbc.password=$tempibmQseInst_PW" >> $BuildResponseFile
      echo "configure.database.page\:db.type=JDBC" >> $BuildResponseFile
      echo "configure.database.page\:db.vendor=DB2" >> $BuildResponseFile

      # configure datawarehouse
      echo "data.warehouse.page\:db.base.folder=/db2fs/db2inst1" >> $BuildResponseFile
      echo "data.warehouse.page\:db.jdbc.location=//$DB_HOSTNAME\:$DB2PORT/$dwDBName\:user\=$ibmQseInst_User;password\={password};" >> $BuildResponseFile
      echo "data.warehouse.page\:db.jdbc.password=$tempibmQseInst_PW" >> $BuildResponseFile
      echo "data.warehouse.page\:db.type=JDBC" >> $BuildResponseFile
      echo "data.warehouse.page\:db.vendor=DB2" >> $BuildResponseFile
      echo "data.warehouse.page\:report.user=RPTUSER" >> $BuildResponseFile
   else
      if [ $DB_VENDOR == oracle ]
      then
         # build oracle common section
         # configure database
         echo "configure.database.page\:db.jdbc.location=thin\:jtsUSR/{password}@//$DB_HOSTNAME\:1521/CLMINST" >> $BuildResponseFile
         echo "configure.database.page\:db.jdbc.password=jtsUSR" >> $BuildResponseFile
         echo "configure.database.page\:db.type=JDBC" >> $BuildResponseFile
         echo "configure.database.page\:db.vendor=ORACLE" >> $BuildResponseFile

         # configure datawarehouse
         echo "data.warehouse.page\:db.base.folder=/db2fs/db2inst1" >> $BuildResponseFile
         echo "data.warehouse.page\:db.jdbc.location=thin\:dwUSR/{password}@//$DB_HOSTNAME\:1521/CLMINST" >> $BuildResponseFile
         echo "data.warehouse.page\:db.jdbc.password=dwUSR" >> $BuildResponseFile
         echo "data.warehouse.page\:db.type=JDBC" >> $BuildResponseFile
         echo "data.warehouse.page\:db.vendor=ORACLE" >> $BuildResponseFile
         echo "data.warehouse.page\:report.user=RPTUSER" >> $BuildResponseFile
      else
         echo "Not support database: [$DB_VENDOR]"
         exit 1
      fi
   fi
}


## parse all apps and only add licenses for apps that are present
## -- assume only one instance of each app
createLicenseSection()
{
  nodeCount=$1
  
  DMpresentFlag=FALSE
  RELMpresentFlag=FALSE
  QMpresentFlag=FALSE
  CCMpresentFlag=FALSE
  RMpresentFlag=FALSE
  
  i=1

  while [ $i -le $nodeCount ]
  do
    c_app_var=NODE${i}_AppList
    eval c_app=\$$c_app_var
    appList=${c_app//,/ }
    for a in $appList
    do
      if [ "dm" == $a  ]; then
        DMpresentFlag=TRUE
      fi
      if [ "relm" == $a  ]; then
        RELMpresentFlag=TRUE
      fi
      if [ "qm" == $a  ]; then
        QMpresentFlag=TRUE
      fi
      if [ "ccm" == $a  ]; then
        CCMpresentFlag=TRUE
      fi
      if [ "rm" == $a  ]; then
        RMpresentFlag=TRUE
      fi
    done
    i=$(( i+1 ))
  done
  
  # add fixed license information
  echo "license.assignment.page\\:com.ibm.team.csm.user.activate.trial=true" >> $BuildResponseFile
  echo "license.assignment.page\\:com.ibm.team.csm.user.agreement=true" >> $BuildResponseFile
  echo "license.assignment.page\\:license.CLMServerMonitoring=com.ibm.team.csm.user" >> $BuildResponseFile

  echo "license.assignment.page\\:license.RationalsolutionforCollaborativeLifecycleManagement=None" >> $BuildResponseFile
  
  # add optional license information
  if [ ${DMpresentFlag} == "TRUE" ]; then
    echo "license.assignment.page\\:com.ibm.xtools.dm.rhapsody.manager.activate.trial=true" >> $BuildResponseFile
    echo "license.assignment.page\\:com.ibm.xtools.dm.rhapsody.manager.agreement=true" >> $BuildResponseFile
    echo "license.assignment.page\\:license.RationalRhapsodyDesignManager=com.ibm.xtools.dm.rhapsody.manager" >> $BuildResponseFile
  else
    echo "license.assignment.page\\:license.RationalRhapsodyDesignManager=None" >> $BuildResponseFile
  fi
  if [ ${RELMpresentFlag} == "TRUE" ]; then
    echo "license.assignment.page\\:license.RationalEngineeringLifecycleManager=com.ibm.team.relm.user" >> $BuildResponseFile
    echo "license.assignment.page\\:com.ibm.team.relm.user.activate.trial=true" >> $BuildResponseFile
    echo "license.assignment.page\\:com.ibm.team.relm.user.agreement=true" >> $BuildResponseFile
  else
    echo "license.assignment.page\\:license.RationalEngineeringLifecycleManager=None" >> $BuildResponseFile
  fi
  if [ ${QMpresentFlag} == "TRUE" ]; then
    echo "license.assignment.page\\:com.ibm.rqm.tester.activate.trial=true" >> $BuildResponseFile
    echo "license.assignment.page\\:com.ibm.rqm.tester.agreement=true" >> $BuildResponseFile
    echo "license.assignment.page\\:license.RationalQualityManager=com.ibm.rqm.tester" >> $BuildResponseFile
  else
    echo "license.assignment.page\\:license.RationalQualityManager=None" >> $BuildResponseFile
  fi
  if [ ${CCMpresentFlag} == "TRUE" ]; then
    ## developer-iep
    ## echo "license.assignment.page\\:com.ibm.rtc.developer-iep.activate.trial=true" >> $BuildResponseFile
    ## echo "license.assignment.page\\:com.ibm.rtc.developer-iep.agreement=true" >> $BuildResponseFile
    ## echo "license.assignment.page\\:license.RationalTeamConcert=com.ibm.rtc.developer-iep" >> $BuildResponseFile
    
    ## developer
    echo "license.assignment.page\:com.ibm.team.rtc.developer.activate.trial=true" >> $BuildResponseFile
    echo "license.assignment.page\:com.ibm.team.rtc.developer.agreement=true" >> $BuildResponseFile
    echo "license.assignment.page\:license.RationalTeamConcert=com.ibm.team.rtc.developer" >> $BuildResponseFile
    
  else
    echo "license.assignment.page\\:license.RationalTeamConcert=None" >> $BuildResponseFile
  fi
  if [ ${RMpresentFlag} == "TRUE" ]; then
    echo "license.assignment.page\\:com.ibm.team.rrc.author.activate.trial=true" >> $BuildResponseFile
    echo "license.assignment.page\\:com.ibm.team.rrc.author.agreement=true" >> $BuildResponseFile
    echo "license.assignment.page\\:license.RationalDOORSNextGeneration=com.ibm.team.rrc.author" >> $BuildResponseFile
  else
    echo "license.assignment.page\\:license.RationalDOORSNextGeneration=None" >> $BuildResponseFile
  fi

}


##########################
# Script Entry
##################
. /etc/env.properties

# get credentials
userCreds=$AUTO_PREP/UserParameters/userCreds.properties
. $userCreds

# Get ibmQseInst_PW Password for the setup
# ======================================
tempibmQseInst_PW=`echo ${ibmQseInst_PW} | base64 -d`

scriptName=$0

# =====================================================================================================
# get the LDAP properties
WAS_SCRIPTS_DIR="$WAS_COMMON_DIR/WASScripts"
WAS_LDAP_DIR="$WAS_COMMON_DIR/LDAP"

if [ -e "$WAS_LDAP_DIR/LDAPSecurity.properties" ]
then
  echo "sourcing $WAS_LDAP_DIR/LDAPSecurity.properties"
  . "$WAS_LDAP_DIR/LDAPSecurity.properties"
else 
  echo "$WAS_LDAP_DIR/LDAPSecurity.properties does not exist."
  exit 1
fi



# build JTS setup
BuildResponseFile=$JTSSetup_DIR/SetupResponse.properties
echo "Build common section...."
echo "admin.access\\:ws.allow.admin.access=true" > $BuildResponseFile
echo "com.ibm.team.lpa.deploySampleStep\\:lpa.deploy.MTM=false" >> $BuildResponseFile

# licensing
createLicenseSection ${NUMBER_OF_CUSTOM_NODES}


# ldap (updated at runtime)
# LDAP property updates

echo "compute.LDAP.queries.step\\:compute.LDAP.queries=true" >> $BuildResponseFile
echo "user.registry.page\\:ldap.baseGroupDN=$jazz_ldap_baseGroupDN" >> $BuildResponseFile
echo "user.registry.page\\:ldap.baseUserDN=$jazz_ldap_baseUserDN" >> $BuildResponseFile
echo "user.registry.page\\:ldap.groupMapping=$jazz_ldap_groupMapping" >> $BuildResponseFile
echo "user.registry.page\\:ldap.groupNameAttribute=$jazz_ldap_groupNameAttribute" >> $BuildResponseFile
echo "user.registry.page\\:ldap.membersOfGroup=$jazz_ldap_membersOfGroup" >> $BuildResponseFile
echo "user.registry.page\\:ldap.registryLocation=ldap\\://$jazz_userrealm" >> $BuildResponseFile
echo "user.registry.page\\:ldap.registryPassword=$jazz_userrole_RegistryPassword" >> $BuildResponseFile
echo "user.registry.page\\:ldap.registryUserName=$jazz_userrole_RegistryUsername" >> $BuildResponseFile
echo "user.registry.page\\:ldap.userAttributesMapping=$jazz_ldap_userAttributesMapping" >> $BuildResponseFile
echo "user.registry.page\\:user.registry.type=LDAP" >> $BuildResponseFile

echo "configure.email.page\\:notification.mail.enabled=false" >> $BuildResponseFile


createCommonDatabaseSection

. /etc/env.properties
i=1
nonlocalApp=0
while [ $i -le $NUMBER_OF_CUSTOM_NODES ]
do 
   if [ $ihshost == UNKNOWN ]
   then
      HostName_var=NODE${i}_HostName
      eval HostName=\$$HostName_var
   else
      HostName=$ihshost
   fi   
   app_var=NODE${i}_AppList
   eval apps=\$$app_var
   
   echo $apps |grep jts
   if [ $? -gt 0 ]
   then
            echo "This is not a jts node"
            
            apps=${apps//,/ }
        echo "apps: [$apps]"
        for a in $apps
        do
           nonlocalApp=$(( nonlocalApp+1 ))
           createDatabaseSection $a $DB_HOSTNAME $nonlocalApp
           echo "$nonlocalApp\\:register.applications.page\:application.discovery.url=https\://$HostName\:9443/$a/scr" >> $BuildResponseFile
           echo "$nonlocalApp\\:register.applications.page\:application.title=/$a" >> $BuildResponseFile
           echo "$nonlocalApp\\:register.applications.page\:application.user.id=${a}_user" >> $BuildResponseFile
           if [ $a == lqe ]
           then
             echo "lqe.$nonlocalApp\\:configure.trs.page\\:trs.add=AddTRS" >> $BuildResponseFile
           fi
        
        done
            
   else
        JTSAppHost=$HostName
        apps=${apps//,/ }
        echo "apps [$apps]"
        for a in $apps
        do
           if [ $a == jts ]
           then
              echo "Skip jts app, it should automatically added"
           else
              createDatabaseSection $a $DB_HOSTNAME 0
              echo "register.applications.page\\:jts.register.$a=true" >> $BuildResponseFile
              echo "register.applications.page\\:$a.discovery.url=https\\://$HostName\\:9443/$a/scr" >> $BuildResponseFile
              echo "register.applications.page\\:$a.application.title=/$a" >> $BuildResponseFile
              if [ $a == lqe ]
              then
                 echo "lqe\\:configure.trs.page\\:trs.add=AddTRS" >> $BuildResponseFile
              fi
           fi
        done
   fi
   i=$(( i+1 ))
done

if [ $ihshost == UNKNOWN ]
   then
      JTSURLHost=$JTSAppHost
   else
      JTSURLHost=$ihshost
fi 
echo "JTSURLHost:  [$JTSURLHost]"
echo "JTSURLHost=$JTSURLHost" >> /etc/env.properties
echo "register.applications.page\\:jts.nonlocal.application.number=$nonlocalApp" >> $BuildResponseFile

echo "-- EOF [${scriptName}] --"
exit 0
